#!/usr/bin/env python
# -*- coding: utf-8 -*-
# generated by wxGlade 0.6.3 on Tue Jun 28 16:32:53 2011

import wx
import sys
import os
import pickle as pickle
#import wx.lib.mixins.listctrl as listmix
#import wx.lib.mixins.listctrl as wxListCtrlAutoWidthMixin
import subprocess
import shlex
import re
import datetime


#----------------------------------------------------------------------------
def latin1_to_ascii(unicrap):
    """This replaces UNICODE Latin-1 characters with
    something equivalent in 7-bit ASCII. All characters in the standard
    7-bit ASCII range are preserved. In the 8th bit range all the Latin-1
    accented letters are stripped of their accents. Most symbol characters
    are converted to something meaninful. Anything not converted is deleted.
    """

    xlate={ 0xc0:'A', 0xc1:'A', 0xc2:'A', 0xc3:'A', 0xc4:'A', 0xc5:'A',
    0xc6:'Ae', 0xc7:'C',
    0xc8:'E', 0xc9:'E', 0xca:'E', 0xcb:'E',
    0xcc:'I', 0xcd:'I', 0xce:'I', 0xcf:'I',
    0xd0:'Th', 0xd1:'N',
    0xd2:'O', 0xd3:'O', 0xd4:'O', 0xd5:'O', 0xd6:'O', 0xd8:'O',
    0xd9:'U', 0xda:'U', 0xdb:'U', 0xdc:'U',
    0xdd:'Y', 0xde:'th', 0xdf:'ss',
    0xe0:'a', 0xe1:'a', 0xe2:'a', 0xe3:'a', 0xe4:'a', 0xe5:'a',
    0xe6:'ae', 0xe7:'c',
    0xe8:'e', 0xe9:'e', 0xea:'e', 0xeb:'e',
    0xec:'i', 0xed:'i', 0xee:'i', 0xef:'i',
    0xf0:'th', 0xf1:'n',
    0xf2:'o', 0xf3:'o', 0xf4:'o', 0xf5:'o', 0xf6:'o', 0xf8:'o',
    0xf9:'u', 0xfa:'u', 0xfb:'u', 0xfc:'u',
    0xfd:'y', 0xfe:'th', 0xff:'y',
    0xa1:'!', 0xa2:'{cent}', 0xa3:'{pound}', 0xa4:'{currency}',
    0xa5:'{yen}', 0xa6:'|', 0xa7:'{section}', 0xa8:'{umlaut}',
    0xa9:'{C}', 0xaa:'{^a}', 0xab:'<<', 0xac:'{not}',
    0xad:'-', 0xae:'{R}', 0xaf:'_', 0xb0:'{degrees}',
    0xb1:'{+/-}', 0xb2:'{^2}', 0xb3:'{^3}', 0xb4:"'",
    0xb5:'{micro}', 0xb6:'{paragraph}', 0xb7:'*', 0xb8:'{cedilla}',
    0xb9:'{^1}', 0xba:'{^o}', 0xbb:'>>',
    0xbc:'{1/4}', 0xbd:'{1/2}', 0xbe:'{3/4}', 0xbf:'?',
    0xd7:'*', 0xf7:'/'
    }

    r = ''
    for i in unicrap:
        if xlate.has_key(ord(i)):
            r += xlate[ord(i)]
        elif ord(i) >= 0x80:
            pass
        else:
            r += i
    return r


#----------------------------------------------------------------------------
class TreeNode(object):
    """Tree-like simple object."""
    def __init__(self, parent=False, value=("", "", "")):
        self.parent = parent
        self.value = value
        self.childlist = []

    def SetData( self, value ):
        """Set value tuple (alias, comment, command)."""
        self.value = value

    def GetData( self ):
        """Get value tuple (alias, comment, command)."""
        return(self.value)

    def SetChildData( self, index, value ):
        """Set value tuple for a given child (index) in the childlist."""
        if len(self.childlist) > index:
           self.childlist[index].SetData(value)

    def SetDataItems( self, alias, comment, command ):
        """Set value data not using a tuple."""
        self.value = ( alias, comment, command )

    def append_item( self, value ):
        """Append a new item (TreeNode without childs) to the list."""
        newobject = TreeNode( self, value )
        newobject.childlist = ""
        self.childlist.append( newobject )

    def append_item_values( self, alias, comment, command ):
        """Append a new item not using a tuple value."""
        self.append_item( (alias, comment, command) )

    def append_section( self, value ):
        """Append a new section (TreeNode with childs) to the list."""
        newobject = TreeNode( self, value )
        self.childlist.append( newobject )

    def append_section_values( self, alias, comment, command ):
        """Append a new section not using a tuple."""
        self.append_section( (alias, comment, command) )

    def alias_unique( self, alias, exclude=-1 ):
        """Check for duplicated aliases. You can exclude a given index."""
        for index, child in enumerate(self.childlist):
            if exclude == index:
                continue   
            if child.value[0] == alias:
                return False
        return True

    def child_up( self, index, limit ):
       """Move an item/section up in the items list."""
       src = index
       if index == 0:
           temp = self.childlist[0]
           self.childlist = self.childlist[1:]
           dst = limit-1
           self.childlist.append(temp)
       else:
           dst = index - 1
           self.childlist[src], self.childlist[dst] = self.childlist[dst], self.childlist[src]
       return dst

    def child_down( self, index, limit ):
       """Move an item/section down in the items list."""
       src = index
       if index == limit-1:
           temp = self.childlist[index]
           self.childlist = self.childlist[0:-1]
           self.childlist.insert(0, temp)
           dst = 0
       else:
           dst = index+1
           self.childlist[src], self.childlist[dst] = self.childlist[dst], self.childlist[src]
       return dst

    def delete_item( self, index ):
        """Delete item in list, given its index."""
        del self.childlist[index]

    def delete_section( self, index ):
        """Delete tree section (also deleting all its childs)."""

        if self.childlist == "" or len(self.childlist)<=index:
           return
     
        section_to_delete = self.childlist[index]
 
        # Delete all children recursively, until childlist is empty:   
        while section_to_delete.childlist != []:
            child = section_to_delete.childlist[0]
            indexchild = 0
            if child.childlist == "":
                section_to_delete.delete_item( indexchild )
            else:
                section_to_delete.delete_section( indexchild )

        # Now delete the section itself
        del self.childlist[index]

    def export_tree_as_aliases( self, fp, level=1 ):
        """Export tree as UNIX system-like aliases."""
        
        indent = "#" * (level + 1)
        quote = "'"
        alias, comment, command = self.value
        for char in ( " ", "+", ",", ";" ):
            alias = alias.replace( char, "_")

        if "$" in command:
            command = frame_1.Replace_System_Vars( command )

        # Item -> end of branch
        if command:
            alias_text = u"alias"

            if u"'" in command and not '"' in command:
                quote = '"'

            # Check if command is a macro and do special checking
            elif command.startswith("!"):
                pass

            elif command.startswith("@"):
                retcode, subcommand = frame_1.Replace_Macro_Vars( command )
                if retcode:
                    command = subcommand
                else:
                    alias_text = u"#alias"
            text = u"{} {}={}{}{}   # {}\n".format( alias_text, alias, quote, 
                                                    command, quote, comment )
            fp.write( latin1_to_ascii(text) )

        else:
            text =  u"\n{} {}\n".format(indent, alias) 
            fp.write( latin1_to_ascii(text) )         
            text = u"{} {}\n".format(indent, comment)
            fp.write( latin1_to_ascii(text) )
            for child in self.childlist:
                child.export_tree_as_aliases( fp, level + 1 )


#----------------------------------------------------------------------------
class AddEdit_Macro(wx.Dialog):
    def __init__(self, *args, **kwds):
        # begin wxGlade: AddEdit_Macro.__init__
        kwds["style"] = wx.DEFAULT_DIALOG_STYLE
        wx.Dialog.__init__(self, *args, **kwds)
        self.label_1_copy = wx.StaticText(self, -1, "Macro Name (*):", style=wx.ALIGN_CENTRE)
        self.AddMacro_Name = wx.TextCtrl(self, -1, "")
        self.label_2_copy = wx.StaticText(self, -1, "Macro command (*):", style=wx.ALIGN_CENTRE)
        self.AddMacro_Command = wx.TextCtrl(self, -1, "")
        self.label_4_copy = wx.StaticText(self, -1, "(*) = required fields")
        self.btn_CancelAddMacro_copy = wx.Button(self, -1, "Cancel")
        self.btn_OKAddMacro_copy = wx.Button(self, -1, "OK")

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.OnBtn_Click_Cancel_AddEditMacro, self.btn_CancelAddMacro_copy)
        self.Bind(wx.EVT_BUTTON, self.OnBtn_Click_OK_AddEditMacro, self.btn_OKAddMacro_copy)
        # end wxGlade

        self.AddMacro_Name.SetFocus()

    def __set_properties(self):
        # begin wxGlade: AddEdit_Macro.__set_properties
        self.SetTitle("Add Macro")
        self.AddMacro_Name.SetMinSize((300, 26))
        self.AddMacro_Command.SetMinSize((300, 26))
        self.btn_OKAddMacro_copy.SetDefault()
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: AddEdit_Macro.__do_layout
        sizer_5_copy = wx.BoxSizer(wx.VERTICAL)
        sizer_6_copy = wx.BoxSizer(wx.HORIZONTAL)
        grid_sizer_2 = wx.FlexGridSizer(6, 3, 0, 0)
        grid_sizer_2.Add((20, 20), 0, 0, 0)
        grid_sizer_2.Add((20, 20), 0, 0, 0)
        grid_sizer_2.Add((20, 20), 0, 0, 0)
        grid_sizer_2.Add(self.label_1_copy, 0, wx.ALIGN_CENTER_VERTICAL, 10)
        grid_sizer_2.Add((20, 20), 0, 0, 0)
        grid_sizer_2.Add(self.AddMacro_Name, 1, 0, 0)
        grid_sizer_2.Add((20, 20), 0, 0, 0)
        grid_sizer_2.Add((20, 20), 0, 0, 0)
        grid_sizer_2.Add((20, 20), 0, 0, 0)
        grid_sizer_2.Add(self.label_2_copy, 0, wx.ALIGN_CENTER_VERTICAL, 10)
        grid_sizer_2.Add((20, 20), 0, 0, 0)
        grid_sizer_2.Add(self.AddMacro_Command, 1, 0, 0)
        grid_sizer_2.Add((20, 20), 0, 0, 0)
        grid_sizer_2.Add((20, 20), 0, 0, 0)
        grid_sizer_2.Add((20, 20), 0, 0, 0)
        grid_sizer_2.Add((20, 20), 0, 0, 0)
        grid_sizer_2.Add((20, 20), 0, 0, 0)
        grid_sizer_2.Add(self.label_4_copy, 0, 0, 0)
        sizer_5_copy.Add(grid_sizer_2, 0, wx.ALL|wx.EXPAND, 10)
        sizer_6_copy.Add(self.btn_CancelAddMacro_copy, 0, 0, 0)
        sizer_6_copy.Add((20, 20), 0, 0, 0)
        sizer_6_copy.Add(self.btn_OKAddMacro_copy, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        sizer_5_copy.Add(sizer_6_copy, 0, wx.ALL|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 15)
        self.SetSizer(sizer_5_copy)
        sizer_5_copy.Fit(self)
        self.Layout()
        # end wxGlade

        self.action = "add_macro"
        self.index = -1

    def OnBtn_Click_Cancel_AddEditMacro(self, event): # wxGlade: AddEdit_Macro.<event_handler>
        self.Destroy()

    def OnBtn_Click_OK_AddEditMacro(self, event): # wxGlade: AddEdit_Macro.<event_handler>
        macro = self.AddMacro_Name.GetValue()

        if not macro.startswith("@"):
            macro = "@" + macro        
        if " " in macro or "\t" in macro:
            wx.MessageBox(u'Error: Macro name cannot contain spaces or tabs.\n', 
                          u'Error', wx.ICON_ERROR)
            return

        for char in [ '"', "+", "'", '"', ",", ";"]:
            macro = macro.replace(char, "_")

        command = self.AddMacro_Command.GetValue()

        if self.action == "add_macro":

            if frame_1.Check_Macro_Exists( macro ):
                wx.MessageBox(u'Error: Macro name already defined in macro list.\n', 
                              u'Error', wx.ICON_ERROR)
                return
            frame_1.macros.append( (macro, command) )

        else:
           frame_1.macros[self.index] = (macro, command)
        frame_1.Save_Data_To_File()
        self.Destroy()

# end of class AddEdit_Macro


#----------------------------------------------------------------------------
class Macros_Dialog(wx.Dialog):
    def __init__(self, *args, **kwds):
        # begin wxGlade: Macros_Dialog.__init__
        kwds["style"] = wx.DEFAULT_DIALOG_STYLE
        wx.Dialog.__init__(self, *args, **kwds)
        self.panel_2_copy = wx.Panel(self, -1)
        self.macros_list = wx.ListCtrl(self.panel_2_copy, -1, style=wx.LC_REPORT|wx.LC_SINGLE_SEL|wx.SUNKEN_BORDER)
        self.mac_btnAdd_macro = wx.Button(self.panel_2_copy, -1, "Add")
        self.mac_btnEdit_macro = wx.Button(self.panel_2_copy, -1, "Edit")
        self.mac_btnDelete_macro = wx.Button(self.panel_2_copy, -1, "Delete")
        self.mac_btnClose_macro = wx.Button(self.panel_2_copy, -1, "Close")

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_LIST_ITEM_DESELECTED, self.onUnselectItem_macros, self.macros_list)
        self.Bind(wx.EVT_LIST_ITEM_SELECTED, self.onSelectItem_macros, self.macros_list)
        self.Bind(wx.EVT_LIST_ITEM_ACTIVATED, self.onActivateItem_macros, self.macros_list)
        self.Bind(wx.EVT_BUTTON, self.OnBtn_Click_Add_Macros, self.mac_btnAdd_macro)
        self.Bind(wx.EVT_BUTTON, self.OnBtn_Click_Edit_Macros, self.mac_btnEdit_macro)
        self.Bind(wx.EVT_BUTTON, self.OnBtn_Click_Delete_Macros, self.mac_btnDelete_macro)
        self.Bind(wx.EVT_BUTTON, self.OnBtn_Click_Close_Macros, self.mac_btnClose_macro)
        # end wxGlade

        self.Bind(wx.EVT_CLOSE, self.OnClose )
        self.Disable_EditDelete()
        self.Populate_macros()

    def __set_properties(self):
        # begin wxGlade: Macros_Dialog.__set_properties
        self.SetTitle("Manage Macros")
        self.SetSize((600, 300))
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: Macros_Dialog.__do_layout
        sizer_8_copy = wx.BoxSizer(wx.HORIZONTAL)
        sizer_9_copy = wx.BoxSizer(wx.VERTICAL)
        sizer_10_copy = wx.BoxSizer(wx.HORIZONTAL)
        grid_sizer_2_copy = wx.FlexGridSizer(3, 3, 0, 0)
        grid_sizer_2_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_2_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_2_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_2_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_2_copy.Add(self.macros_list, 1, wx.EXPAND, 0)
        grid_sizer_2_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_2_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_2_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_2_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_2_copy.AddGrowableRow(1)
        grid_sizer_2_copy.AddGrowableCol(1)
        sizer_9_copy.Add(grid_sizer_2_copy, 1, wx.EXPAND, 0)
        sizer_10_copy.Add((20, 20), 0, 0, 0)
        sizer_10_copy.Add(self.mac_btnAdd_macro, 1, 0, 0)
        sizer_10_copy.Add(self.mac_btnEdit_macro, 1, 0, 0)
        sizer_10_copy.Add(self.mac_btnDelete_macro, 1, 0, 0)
        sizer_10_copy.Add((20, 20), 0, 0, 0)
        sizer_10_copy.Add(self.mac_btnClose_macro, 0, 0, 0)
        sizer_10_copy.Add((20, 20), 0, 0, 0)
        sizer_9_copy.Add(sizer_10_copy, 0, 0, 0)
        sizer_9_copy.Add((20, 10), 0, 0, 0)
        self.panel_2_copy.SetSizer(sizer_9_copy)
        sizer_8_copy.Add(self.panel_2_copy, 1, wx.EXPAND, 0)
        self.SetSizer(sizer_8_copy)
        self.Layout()
        self.Centre()
        # end wxGlade

    def OnClose( self, event ):
        """Save data on frame/dialog close."""
        frame_1.Save_Data_To_File()
        self.Destroy()

    def GetSelectedIndices( self, state =  wx.LIST_STATE_SELECTED):
        """Get indices list of selected items. Valid for SINGLE/MULTI select."""
        indices = []
        lastFound = -1
        while True:
            index = self.macros_list.GetNextItem( lastFound, wx.LIST_NEXT_ALL, state )
            if index == -1:
                break
            else:
                lastFound = index
                indices.append( index )
        return indices

    def Disable_EditDelete( self ):
        """Disable EDIT/DELETE buttons until user selects an item."""
        self.mac_btnEdit_macro.Enable(False)
        self.mac_btnDelete_macro.Enable(False)

    def Enable_EditDelete( self ):
        """Enable EDIT/DELETE buttons."""
        self.mac_btnEdit_macro.Enable()
        self.mac_btnDelete_macro.Enable()

    def Populate_macros( self ):
        """Populate commands list from frame_1.list_commands."""
        self.macros_list.ClearAll()
        format = wx.LIST_FORMAT_LEFT
        self.macros_list.InsertColumn(0, u"Macro alias", width=-2, format=format )
        self.macros_list.InsertColumn(1, u"Command", width=-2, format=format )

        for index, the_macro in enumerate(frame_1.macros):
            macro = the_macro[0]
            command = the_macro[1]
            self.macros_list.InsertStringItem(index, macro)
            self.macros_list.SetStringItem(index, 1, command)

        # Set column sizes (30% and 70%)
        size_w = self.macros_list.GetSize()[0]
        size_a = (25*size_w) / 100
        self.macros_list.SetColumnWidth(0, size_a)
        self.macros_list.SetColumnWidth(1, size_w - size_a)

    def GetDataFromIndex( self, index ):
        """Given an index, return 2 fields of the item."""
        selected = self.macros_list.GetItemState(index, wx.LIST_STATE_SELECTED) & wx.LIST_STATE_SELECTED
        if selected:
           macro = (self.macros_list.GetItem(index, 0)).GetText()
           command = (self.macros_list.GetItem(index, 1)).GetText() 
           item = ( macro, command )
        else:
           item = []
        return item

    def OnBtn_Click_Add_Macros(self, event): # wxGlade: Macros_Dialog.<event_handler>
        """User clicks on "Add"... (macro)."""
        dlg = AddEdit_Macro(None, -1, "")
        dlg.action = "add_macro"
        dlg.index = -1
        dlg.ShowModal()
        dlg.Destroy()
        self.Populate_macros()

    def OnBtn_Click_Edit_Macros(self, event): # wxGlade: Macros_Dialog.<event_handler>
        """User clicks on "Edit"..."""
        indices = self.GetSelectedIndices()
        if indices:
            index = indices[0]
            item = self.GetDataFromIndex( index )
            macro, command = item
            dlg = AddEdit_Macro(None, -1, "")
            dlg.SetTitle(u"Edit Macro")
            dlg.action = "edit_macro"
            dlg.index = index
            dlg.AddMacro_Name.SetValue(macro)
            dlg.AddMacro_Command.SetValue(command)
            dlg.ShowModal()
            dlg.Destroy()
            self.Populate_macros()
            self.Disable_EditDelete()

    def OnBtn_Click_Delete_Macros(self, event): # wxGlade: Macros_Dialog.<event_handler>
        """User clicks on "Delete"..."""
        indices = self.GetSelectedIndices()
        if indices:
            index = indices[0]
            item = self.GetDataFromIndex( index )
            macro, command = item
            dlg = wx.MessageDialog(self, 
                     u'Are you sure you want to delete the following macro?\n\n'
                     u'Macro: "{}"\nCommand: "{}"\n\n'
                     u'This can\'t be undone.'.format(macro, command) , 
                     u'Delete macro', wx.YES | wx.NO | wx.ICON_WARNING )
            result = dlg.ShowModal()
            dlg.Destroy()
            if result == wx.ID_YES:
                del frame_1.macros[index]
                self.Populate_macros()
                frame_1.Save_Data_To_File()
                self.Disable_EditDelete()
            elif result == wx.ID_NO:
                pass
            dlg.Destroy()

    def OnBtn_Click_Close_Macros(self, event): # wxGlade: Macros_Dialog.<event_handler>
        """User clicks on "Close"..."""
        frame_1.Save_Data_To_File()
        self.Destroy()

    def onSelectItem_macros(self, event): # wxGlade: Macros_Dialog.<event_handler>
        """Item is selected."""
        self.Enable_EditDelete()
 
    def onUnselectItem_macros(self, event): # wxGlade: Macros_Dialog.<event_handler>
        """Item is unselected."""
        self.Disable_EditDelete()

    def onActivateItem_macros(self, event): # wxGlade: Macros_Dialog.<event_handler>
        """User double-clicks in an item (-> edit item)."""
        self.OnBtn_Click_Edit_Macros( event )

# end of class Macros_Dialog


#----------------------------------------------------------------------------
class Templates_Dialog(wx.Dialog):
    def __init__(self, *args, **kwds):
        # begin wxGlade: Templates_Dialog.__init__
        kwds["style"] = wx.DEFAULT_DIALOG_STYLE
        wx.Dialog.__init__(self, *args, **kwds)
        self.panel_2 = wx.Panel(self, -1)
        self.templates_list = wx.ListBox(self.panel_2, -1, choices=[], style=wx.LB_SINGLE|wx.LB_HSCROLL|wx.LB_ALWAYS_SB|wx.LB_NEEDED_SB)
        self.tpl_btnAdd = wx.Button(self.panel_2, -1, "Add")
        self.tpl_btnEdit = wx.Button(self.panel_2, -1, "Edit")
        self.tpl_btnDelete = wx.Button(self.panel_2, -1, "Delete")
        self.tpl_btnClose = wx.Button(self.panel_2, -1, "Close")

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_LISTBOX, self.OnBtn_EventListbox, self.templates_list)
        self.Bind(wx.EVT_BUTTON, self.OnBtn_Click_Add_Templates, self.tpl_btnAdd)
        self.Bind(wx.EVT_BUTTON, self.OnBtn_Click_Edit_Templates, self.tpl_btnEdit)
        self.Bind(wx.EVT_BUTTON, self.OnBtn_Click_Delete_Templates, self.tpl_btnDelete)
        self.Bind(wx.EVT_BUTTON, self.OnBtn_Click_Close_Templates, self.tpl_btnClose)
        # end wxGlade

        self.Bind(wx.EVT_CLOSE, self.OnClose )
        self.Disable_EditDelete()
        self.Populate_templates()

    def __set_properties(self):
        # begin wxGlade: Templates_Dialog.__set_properties
        self.SetTitle("Manage template commands")
        self.SetSize((600, 300))
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: Templates_Dialog.__do_layout
        sizer_8 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_9 = wx.BoxSizer(wx.VERTICAL)
        sizer_10 = wx.BoxSizer(wx.HORIZONTAL)
        grid_sizer_2 = wx.FlexGridSizer(3, 3, 0, 0)
        grid_sizer_2.Add((20, 20), 0, 0, 0)
        grid_sizer_2.Add((20, 20), 0, 0, 0)
        grid_sizer_2.Add((20, 20), 0, 0, 0)
        grid_sizer_2.Add((20, 20), 0, 0, 0)
        grid_sizer_2.Add(self.templates_list, 1, wx.EXPAND|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        grid_sizer_2.Add((20, 20), 0, 0, 0)
        grid_sizer_2.Add((20, 20), 0, 0, 0)
        grid_sizer_2.Add((20, 20), 0, 0, 0)
        grid_sizer_2.Add((20, 20), 0, 0, 0)
        grid_sizer_2.AddGrowableRow(1)
        grid_sizer_2.AddGrowableCol(1)
        sizer_9.Add(grid_sizer_2, 1, wx.EXPAND, 0)
        sizer_10.Add((20, 20), 0, 0, 0)
        sizer_10.Add(self.tpl_btnAdd, 1, 0, 0)
        sizer_10.Add(self.tpl_btnEdit, 1, 0, 0)
        sizer_10.Add(self.tpl_btnDelete, 1, 0, 0)
        sizer_10.Add((20, 20), 0, 0, 0)
        sizer_10.Add(self.tpl_btnClose, 0, 0, 0)
        sizer_10.Add((20, 20), 0, 0, 0)
        sizer_9.Add(sizer_10, 0, 0, 0)
        sizer_9.Add((20, 10), 0, 0, 0)
        self.panel_2.SetSizer(sizer_9)
        sizer_8.Add(self.panel_2, 1, wx.EXPAND, 0)
        self.SetSizer(sizer_8)
        self.Layout()
        self.Centre()
        # end wxGlade

    def OnClose( self, event ):
        """Save data on frame/dialog close."""
        frame_1.Save_Data_To_File()
        self.Destroy()

    def Disable_EditDelete( self ):
        """Disable EDIT/DELETE buttons until user selects an item."""
        self.tpl_btnEdit.Enable(False)
        self.tpl_btnDelete.Enable(False)

    def Enable_EditDelete( self ):
        """Enable EDIT/DELETE buttons."""
        self.tpl_btnEdit.Enable()
        self.tpl_btnDelete.Enable()

    def Populate_templates( self ):
        """Populate commands list from frame_1.list_commands."""
        self.templates_list.Clear()
        for command in frame_1.list_commands:
            self.templates_list.Append(command)

    def OnBtn_Click_Add_Templates(self, event): # wxGlade: Templates_Dialog.<event_handler>
        """User clicks on "Add"... (template)."""
        dlg = wx.TextEntryDialog(None, u"Enter a new command template:   ",
                u"Add command template", "", style=wx.OK|wx.CANCEL)
        if dlg.ShowModal() == wx.ID_OK:
            new_template = dlg.GetValue()
            if new_template not in frame_1.list_commands:
                frame_1.list_commands.append(new_template)
            else:
                wx.MessageBox(u'Error: Template already exists in the templates'
                              u' list.\n\n"{}".'.format(new_template), 
                              u'Error', wx.ICON_ERROR)
        dlg.Destroy()
        self.Populate_templates()

    def OnBtn_Click_Edit_Templates(self, event): # wxGlade: Templates_Dialog.<event_handler>
        """User clicks on "Edit"... (template)."""
        index = self.templates_list.GetSelection()
        if index != -1:
            cur_value = frame_1.list_commands[index]
            dlg = wx.TextEntryDialog(None, u"Edit command template:   ",
                u"Edit command template", cur_value, style=wx.OK|wx.CANCEL)
            if dlg.ShowModal() == wx.ID_OK:
                new_template = dlg.GetValue()
                frame_1.list_commands[index] = new_template
            dlg.Destroy()
            self.Populate_templates()
        
    def OnBtn_Click_Delete_Templates(self, event): # wxGlade: Templates_Dialog.<event_handler>
        """User clicks on "Delete"... (template)."""
        index = self.templates_list.GetSelection()
        if index != -1:
            cur_value = frame_1.list_commands[index]
            dlg = wx.MessageDialog(self, 
                     u'Are you sure you want to delete the following template?\n\n'
                     u'Command: "{}"\n\n'
                     u'This can\'t be undone.'.format(cur_value) , 
                     u'Delete template', wx.YES | wx.NO | wx.ICON_WARNING )
            result = dlg.ShowModal()
            dlg.Destroy()
            if result == wx.ID_YES:
                del frame_1.list_commands[index]
            elif result == wx.ID_NO:
                pass
            dlg.Destroy()
            self.Populate_templates()

    def OnBtn_Click_Close_Templates(self, event): # wxGlade: Templates_Dialog.<event_handler>
        """User clicks on "Close"..."""
        frame_1.Save_Data_To_File()
        self.Destroy()

    def OnBtn_EventListbox(self, event): # wxGlade: Templates_Dialog.<event_handler>
        index = self.templates_list.GetSelection()
        if index != -1:
            self.Enable_EditDelete()
        else:
            self.Disable_EditDelete()
        event.Skip()
# end of class Templates_Dialog
           
           
#----------------------------------------------------------------------------
class AddEdit_Section_Dialog(wx.Dialog):
    """ADD / EDIT section dialog."""
    def __init__(self, *args, **kwds):
        # begin wxGlade: AddEdit_Section_Dialog.__init__
        kwds["style"] = wx.DEFAULT_DIALOG_STYLE
        wx.Dialog.__init__(self, *args, **kwds)
        self.label_1 = wx.StaticText(self, -1, "Section Name (*):", style=wx.ALIGN_CENTRE)
        self.AddSection_Name = wx.TextCtrl(self, -1, "")
        self.label_2 = wx.StaticText(self, -1, "Section Comment:", style=wx.ALIGN_CENTRE)
        self.AddSection_Comment = wx.TextCtrl(self, -1, "")
        self.label_4 = wx.StaticText(self, -1, "(*) = required fields")
        self.btn_CancelAddSection = wx.Button(self, -1, "Cancel")
        self.btn_OKAddSection = wx.Button(self, -1, "OK")

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.OnBtn_Click_Cancel_AddEditSection, self.btn_CancelAddSection)
        self.Bind(wx.EVT_BUTTON, self.OnBtn_Click_OK_AddEditSection, self.btn_OKAddSection)
        # end wxGlade

        self.action = "add_section" 

    def __set_properties(self):
        # begin wxGlade: AddEdit_Section_Dialog.__set_properties
        self.SetTitle("Add Section")
        self.AddSection_Name.SetMinSize((300, 26))
        self.AddSection_Comment.SetMinSize((300, 26))
        self.btn_OKAddSection.SetDefault()
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: AddEdit_Section_Dialog.__do_layout
        sizer_5 = wx.BoxSizer(wx.VERTICAL)
        sizer_6 = wx.BoxSizer(wx.HORIZONTAL)
        grid_sizer_1 = wx.FlexGridSizer(6, 3, 0, 0)
        grid_sizer_1.Add((20, 20), 0, 0, 0)
        grid_sizer_1.Add((20, 20), 0, 0, 0)
        grid_sizer_1.Add((20, 20), 0, 0, 0)
        grid_sizer_1.Add(self.label_1, 0, wx.ALIGN_CENTER_VERTICAL, 10)
        grid_sizer_1.Add((20, 20), 0, 0, 0)
        grid_sizer_1.Add(self.AddSection_Name, 1, 0, 0)
        grid_sizer_1.Add((20, 20), 0, 0, 0)
        grid_sizer_1.Add((20, 20), 0, 0, 0)
        grid_sizer_1.Add((20, 20), 0, 0, 0)
        grid_sizer_1.Add(self.label_2, 0, wx.ALIGN_CENTER_VERTICAL, 10)
        grid_sizer_1.Add((20, 20), 0, 0, 0)
        grid_sizer_1.Add(self.AddSection_Comment, 1, 0, 0)
        grid_sizer_1.Add((20, 20), 0, 0, 0)
        grid_sizer_1.Add((20, 20), 0, 0, 0)
        grid_sizer_1.Add((20, 20), 0, 0, 0)
        grid_sizer_1.Add((20, 20), 0, 0, 0)
        grid_sizer_1.Add((20, 20), 0, 0, 0)
        grid_sizer_1.Add(self.label_4, 0, 0, 0)
        sizer_5.Add(grid_sizer_1, 0, wx.ALL|wx.EXPAND, 10)
        sizer_6.Add(self.btn_CancelAddSection, 0, 0, 0)
        sizer_6.Add((20, 20), 0, 0, 0)
        sizer_6.Add(self.btn_OKAddSection, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        sizer_5.Add(sizer_6, 0, wx.ALL|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 15)
        self.SetSizer(sizer_5)
        sizer_5.Fit(self)
        self.Layout()
        self.Centre()
        # end wxGlade
        self.AddSection_Name.SetFocus()

    def OnBtn_Click_OK_AddEditSection(self, event): # wxGlade: AddEdit_Section_Dialog.<event_handler>
        """User clicks on OK in the ADD/EDIT Section dialog."""
        alias = self.AddSection_Name.GetValue()
        comment = self.AddSection_Comment.GetValue()
        command = ""
        item = ( alias, comment, command )
        # "alias" is a required field: can't be empty
        if alias:
            if self.action == "add_section":
                if frame_1.Add_Item_Section( event, item ):
                    self.Destroy()
            elif self.action == "edit_section":
                if frame_1.Edit_Item_Section( event, item, self.index_edit ):
                    self.Destroy()
        else:
            wx.MessageBox(u'Missing data in required fields.', 'Error', wx.ICON_ERROR)

    def OnBtn_Click_Cancel_AddEditSection(self, event): # wxGlade: AddEdit_Section_Dialog.<event_handler>
        """User clicks on CANCEL in the ADD/EDIT Section dialog."""
        self.Destroy()

# end of class AddEdit_Section_Dialog


#----------------------------------------------------------------------------
class AddEdit_Dialog(wx.Dialog):
    """ADD / EDIT item dialog."""
    def __init__(self, *args, **kwds):
        # begin wxGlade: AddEdit_Dialog.__init__
        kwds["style"] = wx.DEFAULT_DIALOG_STYLE
        wx.Dialog.__init__(self, *args, **kwds)
        self.label_1_add = wx.StaticText(self, -1, "Item Name (*):", style=wx.ALIGN_CENTRE)
        self.AddItem_Name = wx.TextCtrl(self, -1, "")
        self.label_2_add = wx.StaticText(self, -1, "Item Comment:", style=wx.ALIGN_CENTRE)
        self.AddItem_Comment = wx.TextCtrl(self, -1, "")
        self.label_3_command = wx.StaticText(self, -1, "Command (*):")
        self.AddItem_Command = wx.TextCtrl(self, -1, "")
        self.button_templates = wx.Button(self, -1, "...", style=wx.BU_EXACTFIT)
        self.label_3 = wx.StaticText(self, -1, "(*) = required fields")
        self.btn_CancelAdd = wx.Button(self, -1, "Cancel")
        self.btn_OKAdd = wx.Button(self, -1, "OK")

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.OnBtn_Click_Templates_AddEdit, self.button_templates)
        self.Bind(wx.EVT_BUTTON, self.OnBtn_Click_Cancel_AddEdit, self.btn_CancelAdd)
        self.Bind(wx.EVT_BUTTON, self.OnBtn_Click_OK_AddEdit, self.btn_OKAdd)
        # end wxGlade
        self.action = "add_item"

    def __set_properties(self):
        # begin wxGlade: AddEdit_Dialog.__set_properties
        self.SetTitle("Add item")
        self.AddItem_Name.SetMinSize((300, 26))
        self.AddItem_Comment.SetMinSize((300, 26))
        self.AddItem_Command.SetMinSize((300, 26))
        self.btn_OKAdd.SetDefault()
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: AddEdit_Dialog.__do_layout
        sizer_3 = wx.BoxSizer(wx.VERTICAL)
        sizer_4 = wx.BoxSizer(wx.HORIZONTAL)
        grid_sizer_1_copy = wx.FlexGridSizer(8, 4, 0, 0)
        grid_sizer_1_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_1_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_1_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_1_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_1_copy.Add(self.label_1_add, 0, wx.ALIGN_CENTER_VERTICAL, 10)
        grid_sizer_1_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_1_copy.Add(self.AddItem_Name, 1, 0, 0)
        grid_sizer_1_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_1_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_1_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_1_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_1_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_1_copy.Add(self.label_2_add, 0, wx.ALIGN_CENTER_VERTICAL, 10)
        grid_sizer_1_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_1_copy.Add(self.AddItem_Comment, 1, 0, 0)
        grid_sizer_1_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_1_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_1_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_1_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_1_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_1_copy.Add(self.label_3_command, 0, 0, 0)
        grid_sizer_1_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_1_copy.Add(self.AddItem_Command, 0, 0, 0)
        grid_sizer_1_copy.Add(self.button_templates, 0, 0, 0)
        grid_sizer_1_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_1_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_1_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_1_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_1_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_1_copy.Add((20, 20), 0, 0, 0)
        grid_sizer_1_copy.Add(self.label_3, 0, 0, 0)
        grid_sizer_1_copy.Add((20, 20), 0, 0, 0)
        sizer_3.Add(grid_sizer_1_copy, 0, wx.ALL|wx.EXPAND, 15)
        sizer_4.Add(self.btn_CancelAdd, 0, 0, 0)
        sizer_4.Add((20, 20), 0, 0, 0)
        sizer_4.Add(self.btn_OKAdd, 0, 0, 0)
        sizer_3.Add(sizer_4, 0, wx.ALL|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 15)
        self.SetSizer(sizer_3)
        sizer_3.Fit(self)
        self.Layout()
        self.Centre()
        # end wxGlade
        self.AddItem_Name.SetFocus()

    def OnBtn_Click_OK_AddEdit(self, event): # wxGlade: AddEdit_Dialog.<event_handler>
        """User clicks on OK in the ADD/EDIT Item dialog."""
        alias = self.AddItem_Name.GetValue()
        comment = self.AddItem_Comment.GetValue()
        command = self.AddItem_Command.GetValue()

        # Check if command is a macro and do special checking
        if command.startswith("@"):
            retcode, subcommand = frame_1.Replace_Macro_Vars( command )
            if retcode == -2:
                wx.MessageBox(u'ERROR:\n\nCommand references a macro that does not exist.'
                              u'\n\nCommand: "{}"\n'.format(command),
                              u'Error', wx.ICON_ERROR)
                return
            elif retcode == -3:
                wx.MessageBox(u'ERROR:\n\nUnexpected macro argument in command.'
                              u'\n\nCommand: "{}"\nUnexpected argument: "{}"'.format(command,subcommand),
                              u'Error', wx.ICON_ERROR)
                return
            elif retcode == -4:
                wx.MessageBox(u'ERROR:\n\nMissing macro argument in command.'
                              u'\n\nCommand: "{}"\nMissing argument: "{}"'.format(command,subcommand),
                              u'Error', wx.ICON_ERROR)
                return

        item = ( alias, comment, command )
        if alias and command:
            if self.action == "add_item":
                if frame_1.Add_Item_Section( event, item ):
                    self.Destroy()
            elif self.action == "edit_item":
                if frame_1.Edit_Item_Section( event, item, self.index_edit ):
                    self.Destroy()
        else:
            wx.MessageBox(u'Missing data in required fields.', 'Error', wx.ICON_ERROR)

    def OnBtn_Click_Cancel_AddEdit(self, event): # wxGlade: AddEdit_Dialog.<event_handler>
        """User clicks on CANCEL in the ADD/EDIT Item dialog."""
        self.Destroy()

    def OnBtn_Click_Templates_AddEdit(self, event): # wxGlade: AddEdit_Dialog.<event_handler>
        """User clicks in the [...] (Select template/macro) button in ADD/EDIT Item dialog."""
        options = [ u"Insert command template.", u"Insert call to command macro." ]
        dlg = wx.SingleChoiceDialog(self, u'Use template or macro', u'What do you want to do?', 
              options, wx.CHOICEDLG_STYLE)
        if dlg.ShowModal() == wx.ID_OK:
           choose = dlg.GetSelection()
           dlg.Destroy()
           if choose == 0:
               self.SelectTemplate(event)
           else:
               self.SelectMacro(event)

    def SelectMacro(self, event):
        """User choose to insert a call to a command macro."""
        macros = [ " -> ".join(x) for x in frame_1.macros ]
        dlg = wx.SingleChoiceDialog(self, u'Command Macros', u'Select a command macro...', 
              macros, wx.CHOICEDLG_STYLE)
        if dlg.ShowModal() == wx.ID_OK:
           choose = dlg.GetSelection()
           dlg.Destroy()
           macro = self.BuildMacro( choose )
           self.AddItem_Command.SetValue(macro)

    def BuildMacro( self, index ):
        """Return macro ready for insert it as a command."""
        macro = frame_1.macros[index][0]
        command = frame_1.macros[index][1]
        macrovars = frame_1.Extract_Macro_Vars( command )
        if macrovars:
            macrovars = [ var + '="VALUE"' for var in macrovars ]
            varstring = " " + " ".join(macrovars)
        else:
            varstring = " "
        ret = "{}{}".format(macro, varstring)
        return ret

    def SelectTemplate(self, event):
        """User choose to insert a command template."""
        dlg = wx.SingleChoiceDialog(self, u'Command Templates', u'Select a command template...', 
              frame_1.list_commands, wx.CHOICEDLG_STYLE)
        if dlg.ShowModal() == wx.ID_OK:
           choose = dlg.GetStringSelection()
           dlg.Destroy()
           self.AddItem_Command.SetValue(choose)

    def Set_ShowMenu_Status(self):
        pass

# end of class AddEdit_Dialog


#----------------------------------------------------------------------------
class MainFrame(wx.Frame):
    """Main frame."""
    def __init__(self, *args, **kwds):
        # begin wxGlade: MainFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.panel_1 = wx.Panel(self, -1)
        
        # Menu Bar
        self.MainFrame_menubar = wx.MenuBar()
        self.FileMenu = wx.Menu()
        self.ExportAliases = wx.MenuItem(self.FileMenu, wx.NewId(), "Export as aliases", "Export commands as UNIX aliases", wx.ITEM_NORMAL)
        self.FileMenu.AppendItem(self.ExportAliases)
        self.FileMenu.AppendSeparator()
        self.ExitProgram = wx.MenuItem(self.FileMenu, wx.NewId(), "E&xit", "Exit program", wx.ITEM_NORMAL)
        self.FileMenu.AppendItem(self.ExitProgram)
        self.MainFrame_menubar.Append(self.FileMenu, "&File")
        self.EditMenu = wx.Menu()
        self.CutMenu = wx.MenuItem(self.EditMenu, wx.NewId(), "Cut", "Cut selected item/section", wx.ITEM_NORMAL)
        self.EditMenu.AppendItem(self.CutMenu)
        self.CopyMenu = wx.MenuItem(self.EditMenu, wx.NewId(), "Copy", "Copy selected item/section", wx.ITEM_NORMAL)
        self.EditMenu.AppendItem(self.CopyMenu)
        self.PasteMenu = wx.MenuItem(self.EditMenu, wx.NewId(), "Paste", "Paste item", wx.ITEM_NORMAL)
        self.EditMenu.AppendItem(self.PasteMenu)
        self.MainFrame_menubar.Append(self.EditMenu, "&Edit")
        self.ItemMenu = wx.Menu()
        self.OpenItem = wx.MenuItem(self.ItemMenu, wx.NewId(), "Open item", "Open selected item or enter selected section", wx.ITEM_NORMAL)
        self.ItemMenu.AppendItem(self.OpenItem)
        self.EditItem = wx.MenuItem(self.ItemMenu, wx.NewId(), "Edit Item", "Edit current item or section", wx.ITEM_NORMAL)
        self.ItemMenu.AppendItem(self.EditItem)
        self.AddItem = wx.MenuItem(self.ItemMenu, wx.NewId(), "Add Item", "Add a new item", wx.ITEM_NORMAL)
        self.ItemMenu.AppendItem(self.AddItem)
        self.AddSection = wx.MenuItem(self.ItemMenu, wx.NewId(), "Add Section", "Add a new section", wx.ITEM_NORMAL)
        self.ItemMenu.AppendItem(self.AddSection)
        self.DeleteMenu = wx.MenuItem(self.ItemMenu, wx.NewId(), "Delete Item", "Delete selected item", wx.ITEM_NORMAL)
        self.ItemMenu.AppendItem(self.DeleteMenu)
        self.ItemMenu.AppendSeparator()
        self.ManageCommands = wx.MenuItem(self.ItemMenu, wx.NewId(), "Manage Templates", "Manage command template list", wx.ITEM_NORMAL)
        self.ItemMenu.AppendItem(self.ManageCommands)
        self.ManageMacros = wx.MenuItem(self.ItemMenu, wx.NewId(), "Manage Macros", "Manage command macros", wx.ITEM_NORMAL)
        self.ItemMenu.AppendItem(self.ManageMacros)
        self.MainFrame_menubar.Append(self.ItemMenu, "&Items")
        self.ShowMenu = wx.Menu()
        self.ShowIndexes = wx.MenuItem(self.ShowMenu, wx.NewId(), "Show Indexes", "Show \"#\" column", wx.ITEM_CHECK)
        self.ShowMenu.AppendItem(self.ShowIndexes)
        self.ShowComments = wx.MenuItem(self.ShowMenu, wx.NewId(), "Show Comments", "Show \"Comment\" column", wx.ITEM_CHECK)
        self.ShowMenu.AppendItem(self.ShowComments)
        self.ShowCommands = wx.MenuItem(self.ShowMenu, wx.NewId(), "Show Commands", "Show \"Command\" column", wx.ITEM_CHECK)
        self.ShowMenu.AppendItem(self.ShowCommands)
        self.CenterItems = wx.MenuItem(self.ShowMenu, wx.NewId(), "Center items", "Center items in the cell", wx.ITEM_CHECK)
        self.ShowMenu.AppendItem(self.CenterItems)
        self.MainFrame_menubar.Append(self.ShowMenu, "&Headers")
        self.HelpAbout = wx.Menu()
        self.BasicHelp = wx.MenuItem(self.HelpAbout, wx.NewId(), "Basic help", "Basic Help", wx.ITEM_NORMAL)
        self.HelpAbout.AppendItem(self.BasicHelp)
        self.AboutMenu = wx.MenuItem(self.HelpAbout, wx.NewId(), "About...", "About this program", wx.ITEM_NORMAL)
        self.HelpAbout.AppendItem(self.AboutMenu)
        self.MainFrame_menubar.Append(self.HelpAbout, "Help")
        self.SetMenuBar(self.MainFrame_menubar)
        # Menu Bar end
        self.MainFrame_statusbar = self.CreateStatusBar(1, 0)
        self.mainlist = wx.ListCtrl(self.panel_1, -1, style=wx.LC_REPORT|wx.LC_AUTOARRANGE|wx.SUNKEN_BORDER)
        self.button_launch = wx.Button(self, -1, "Open")
        self.button_back = wx.Button(self, -1, "Go up")
        self.button_add = wx.Button(self, -1, "&Add")
        self.button_delete = wx.Button(self, -1, "&Delete")
        self.button_edit = wx.Button(self, -1, "Edit")
        self.button_moveup = wx.Button(self, -1, "Move &up")
        self.button_movedown = wx.Button(self, -1, "Move do&wn")

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_MENU, self.OnSelect_File_ExportAlias, self.ExportAliases)
        self.Bind(wx.EVT_MENU, self.OnSelect_File_Exit, self.ExitProgram)
        self.Bind(wx.EVT_MENU, self.OnBtn_ClickCut, self.CutMenu)
        self.Bind(wx.EVT_MENU, self.OnBtn_ClickCopy, self.CopyMenu)
        self.Bind(wx.EVT_MENU, self.OnBtn_ClickPaste, self.PasteMenu)
        self.Bind(wx.EVT_MENU, self.OnBtn_ClickOpen, self.OpenItem)
        self.Bind(wx.EVT_MENU, self.OnBtn_ClickEdit, self.EditItem)
        self.Bind(wx.EVT_MENU, self.OnBtn_ClickAddItem, self.AddItem)
        self.Bind(wx.EVT_MENU, self.OnBtn_ClickAddSection, self.AddSection)
        self.Bind(wx.EVT_MENU, self.OnBtn_ClickDelete, self.DeleteMenu)
        self.Bind(wx.EVT_MENU, self.OnBtn_ClickManageTemplates, self.ManageCommands)
        self.Bind(wx.EVT_MENU, self.OnBtn_ClickManageMacros, self.ManageMacros)
        self.Bind(wx.EVT_MENU, self.OnBtn_ToggleShowIndexes, self.ShowIndexes)
        self.Bind(wx.EVT_MENU, self.OnBtn_ToggleShowComments, self.ShowComments)
        self.Bind(wx.EVT_MENU, self.OnBtn_ToggleShowCommands, self.ShowCommands)
        self.Bind(wx.EVT_MENU, self.OnBtn_ToggleCenterItems, self.CenterItems)
        self.Bind(wx.EVT_MENU, self.OnBtn_BasicHelp, self.BasicHelp)
        self.Bind(wx.EVT_MENU, self.OnSelect_Help_About, self.AboutMenu)
        self.Bind(wx.EVT_LIST_ITEM_DESELECTED, self.onUnSelectItem_mainlist, self.mainlist)
        self.Bind(wx.EVT_LIST_ITEM_SELECTED, self.onSelectItem_mainlist, self.mainlist)
        self.Bind(wx.EVT_LIST_ITEM_ACTIVATED, self.OnBtn_ClickOpen, self.mainlist)
        self.Bind(wx.EVT_BUTTON, self.OnBtn_ClickOpen, self.button_launch)
        self.Bind(wx.EVT_BUTTON, self.OnBtn_ClickPrevious, self.button_back)
        self.Bind(wx.EVT_BUTTON, self.OnBtn_ClickAdd, self.button_add)
        self.Bind(wx.EVT_BUTTON, self.OnBtn_ClickDelete, self.button_delete)
        self.Bind(wx.EVT_BUTTON, self.OnBtn_ClickEdit, self.button_edit)
        self.Bind(wx.EVT_BUTTON, self.OnBtn_ClickMoveUp, self.button_moveup)
        self.Bind(wx.EVT_BUTTON, self.OnBtn_ClickMoveDown, self.button_movedown)
        # end wxGlade

        # Custom events not defined with wxglade
        self.Bind(wx.EVT_SIZE, self.OnSize)

        # POPUP menu
        self.popupmenu = wx.Menu()
        self.popup_cut = self.popupmenu.Append(-1, "Cut")
        self.Bind(wx.EVT_MENU, self.OnBtn_ClickCut, self.popup_cut)
        self.popup_copy = self.popupmenu.Append(-1, "Copy")
        self.Bind(wx.EVT_MENU, self.OnBtn_ClickCopy, self.popup_copy)
        self.popup_paste = self.popupmenu.Append(-1, "Paste")
        self.Bind(wx.EVT_MENU, self.OnBtn_ClickPaste, self.popup_paste)
        self.popup_edit = self.popupmenu.Append(-1, "Edit")
        self.Bind(wx.EVT_MENU, self.OnBtn_ClickEdit, self.popup_edit)
        self.popup_delete = self.popupmenu.Append(-1, "Delete")
        self.Bind(wx.EVT_MENU, self.OnBtn_ClickDelete, self.popup_delete)
        self.popup_up = self.popupmenu.Append(-1, "Move Up")
        self.Bind(wx.EVT_MENU, self.OnBtn_ClickMoveUp, self.popup_up)
        self.popup_down = self.popupmenu.Append(-1, "Move Down")
        self.Bind(wx.EVT_MENU, self.OnBtn_ClickMoveDown, self.popup_down)
        self.popup_open = self.popupmenu.Append(-1, "Open")
        self.Bind(wx.EVT_MENU, self.OnBtn_ClickOpen, self.popup_open)

        wx.EVT_LIST_ITEM_RIGHT_CLICK( self.mainlist, -1, self.OnShowPopup )
        self.Bind(wx.EVT_CLOSE, self.OnClose )

        # Create an accelerator table
        cut_it_id = wx.NewId()
        copy_it_id = wx.NewId()
        paste_it_id = wx.NewId()
        delete_it_id = wx.NewId()
        self.Bind(wx.EVT_MENU, self.onCtrlX, id=cut_it_id)
        self.Bind(wx.EVT_MENU, self.onCtrlC, id=copy_it_id)
        self.Bind(wx.EVT_MENU, self.onCtrlV, id=paste_it_id)
        self.Bind(wx.EVT_MENU, self.onCtrlD, id=delete_it_id)
 
        self.accel_tbl = wx.AcceleratorTable( [
                    (wx.ACCEL_CTRL, ord('X'), cut_it_id),
                    (wx.ACCEL_CTRL, ord('C'), copy_it_id),
                    (wx.ACCEL_CTRL, ord('V'), paste_it_id),
                    (wx.ACCEL_CTRL, ord('D'), delete_it_id),
                                              ])
        self.SetAcceleratorTable(self.accel_tbl)

        # "Global" variables
        self.Set_Config_File(".wxmylauncher.dat")
        self.clipboard_alias = u"New alias"
        self.clipboard_comment = u"New comment"
        self.clipboard_command = u"New command"
        self.show_indexes = True
        self.show_comment = True
        self.show_command = True
        self.center_items = False

        # Disable ADD/EDIT/DELETE buttons/menues until user clicks in a listctrl item
        self.Disable_LaunchAddEditDelete()
        self.PasteMenu.Enable(False)
        self.popup_paste.Enable(False)

    def onCtrlX(self, event):
        """User pressed Ctrl+X"""
        self.OnBtn_ClickCut(event)

    def onCtrlC(self, event):
        """User pressed Ctrl+C"""
        self.OnBtn_ClickCopy(event)

    def onCtrlV(self, event):
        """User pressed Ctrl+V"""
        self.OnBtn_ClickPaste(event)

    def onCtrlD(self, event):
        """User pressed Ctrl+D"""
        self.OnBtn_ClickDelete(event)
 
    def OnClose( self, event ):
        """Save data on frame/dialog close."""
        frame_1.Save_Data_To_File()
        self.Destroy()

    def Set_CheckMenues( self ):
        """Change checkbox menues according to show_* global vars."""
        self.ShowIndexes.Check( self.show_indexes )
        self.ShowComments.Check( self.show_comment )
        self.ShowCommands.Check( self.show_command )
        self.CenterItems.Check( self.center_items )

    def mainlist_GetDataFromIndex( self, index ):
        """Get data from the tree given an index."""
        return self.cur_tree_pos.childlist[index].value

    def OnShowPopup(self, event):
        """Popup menu."""
        pos = event.GetPosition()
        #pos = self.panel_1.ScreenToClient(pos)
        indices = self.GetSelectedIndices()
        num_items = len(indices)

        # No item selected -> return
        if num_items < 0:
            return
        # 1 item selected -> show standard popup menu
        elif num_items == 1:
            index = indices[0]
            item = self.mainlist_GetDataFromIndex( index )
            alias, comment, cmd = item
            if not cmd:
               # Is a section -> disable Cut / Copy
               self.popup_copy.Enable(False)
               self.popup_cut.Enable(False)
            else:
               # Is an item -> enable all options
               self.popup_copy.Enable()
               self.popup_cut.Enable()
               self.popup_delete.Enable()
               self.popup_up.Enable()
               self.popup_down.Enable()
        else:
               # Is a multiple selection -> disable all but "Open".
               self.popup_copy.Enable(False)
               self.popup_cut.Enable(False)
               self.popup_edit.Enable(False)
               self.popup_delete.Enable(False)
               self.popup_up.Enable(False)
               self.popup_down.Enable(False)

        self.panel_1.PopupMenu(self.popupmenu, pos)

    def __set_properties(self):
        # begin wxGlade: MainFrame.__set_properties
        self.SetTitle("wxMyLauncher")
        self.SetSize((700, 500))
        self.MainFrame_statusbar.SetStatusWidths([-1])
        # statusbar fields
        MainFrame_statusbar_fields = ["wxMyLauncher"]
        for i in range(len(MainFrame_statusbar_fields)):
            self.MainFrame_statusbar.SetStatusText(MainFrame_statusbar_fields[i], i)
        self.button_back.Enable(False)
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MainFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_2 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_7 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_7.Add(self.mainlist, 1, wx.EXPAND, 1)
        self.panel_1.SetSizer(sizer_7)
        sizer_1.Add(self.panel_1, 1, wx.EXPAND, 0)
        sizer_2.Add(self.button_launch, 1, 0, 0)
        sizer_2.Add(self.button_back, 1, 0, 0)
        sizer_2.Add(self.button_add, 1, 0, 0)
        sizer_2.Add(self.button_delete, 1, 0, 0)
        sizer_2.Add(self.button_edit, 1, 0, 0)
        sizer_2.Add(self.button_moveup, 1, 0, 0)
        sizer_2.Add(self.button_movedown, 1, 0, 0)
        sizer_1.Add(sizer_2, 0, wx.EXPAND|wx.ALIGN_CENTER_VERTICAL, 0)
        self.SetSizer(sizer_1)
        self.Layout()
        self.Centre()
        # end wxGlade

    def Set_Config_File(self, filename):
        """Set config file as a "global" variable."""
        
        if not "/" in filename:
            self.home_dir = os.environ['HOME']
            self.config_file = os.path.join( self.home_dir, filename)
        else:
            self.config_file = filename

    def Load_Data_From_File(self):
        """Load data from the config file."""

        can_open = True

        cfg = self.config_file
        try:
            fp = open(cfg)
        except IOError:
            can_open = False

        # Able to open file: process it:
        if can_open:
            self.items_tree = pickle.load( fp )
            self.list_commands = pickle.load( fp )
            self.macros = pickle.load( fp )
            self.show_indexes = pickle.load( fp )
            self.show_comment = pickle.load( fp )
            self.show_command = pickle.load( fp )
            self.center_items = pickle.load( fp )
            self.Set_CheckMenues()
            fp.close()
            self.Populate_mainlist( self.items_tree )

        # Unable to open file: warn user and create empty config file.
        else:
            dlg = wx.MessageDialog(self, 
                      u"Cannot open data file '{}'.\n\n"
                      u"A new data file will be created when you add the first\n"
                      u"item or section in the commands list.".format(cfg),
                      u"Warning", wx.OK | wx.ICON_INFORMATION )
            dlg.ShowModal()
            dlg.Destroy()
            self.items_tree = TreeNode( value=("ROOT", "ROOT", "") )
            self.list_commands = []
            self.macros = []
            self.show_indexes = True
            self.show_comment = True
            self.show_command = True
            self.center_items = False
            self.Set_CheckMenues()
            default_commands = [
               u"gnome-terminal --geometry 98x34 --hide-menubar -t SERVER -x ssh USER@SERVER",
               u"konsole --vt_sz 98x34 --hide-menubar -e ssh USER@SERVER",
               u"xterm -g 98x34 -e ssh SERVER",
               u"rdesktop -g 1024x768 SERVER",
               u"vncviewer -geometry 1024x768 SERVER:0",
               u"tightvncviewer -geometry 1024x768 SERVER:0"
                                ]
            self.list_commands.extend(default_commands)
            default_macros = [
               ( u"@gnometerminal", "gnome-terminal --geometry 98x34 --hide-menubar -t ${USER} -x ssh ${USER}@${SERVER}" ),
               ( u"@rdesktop", "rdesktop -g 1024x768 ${SERVER}" )
                             ]
            self.macros.extend( default_macros )

        self.cur_tree_pos = self.items_tree

    def Save_Data_To_File(self):
        """Save data to config file."""

        can_write = True

        cfg = self.config_file
        try:
            fp = open(cfg, "w")
        except IOError:
            can_write = False

        # Able to open file: process it:
        if can_write:
            pickle.dump( self.items_tree, fp )
            pickle.dump( self.list_commands, fp )
            pickle.dump( self.macros, fp )
            pickle.dump( self.show_indexes, fp )
            pickle.dump( self.show_comment, fp )
            pickle.dump( self.show_command, fp )
            pickle.dump( self.center_items, fp )
            fp.close()

        # Unable to open file: warn user and create empty config file.
        else:
            dlg = wx.MessageDialog(self, 
                      u"Cannot open config file '{}' for writing.".format(cfg),
                      u"Warning", wx.OK | wx.ERROR_INFORMATION )
            dlg.ShowModal()
            dlg.Destroy()
            self.Destroy()

    def Clear_mainlist_Headers( self ):
        """Clear list and add headers in frame_1.mainlist."""
        self.mainlist.ClearAll()

    def Add_mainlist_Headers( self ):
        """Clear list and add headers in frame_1.mainlist."""
        format = wx.LIST_FORMAT_LEFT
        if self.center_items:
            format= wx.LIST_FORMAT_CENTRE

        if self.show_indexes:
            self.mainlist.InsertColumn(0, "#", width=20, format=format )
            next_item = 1
        else:
            next_item = 0

        self.mainlist.InsertColumn(next_item, "Alias", width=150, format=format )
        next_item += 1
        if self.show_comment:
            self.mainlist.InsertColumn(next_item, "Comment", width=-1, format=format )
            next_item += 1
        if self.show_command:
            self.mainlist.InsertColumn(next_item, "Command", width=-1, format=format )

    def Populate_mainlist(self, tree ):
        """Populate mainlist widget with the specified tree brach data."""

        # Clear list and add headers.
        self.Clear_mainlist_Headers()
        self.Add_mainlist_Headers()

        # Populate the listctrl with data in the current tree "branch":
        for index, item in enumerate(tree.childlist):
            alias = item.value[0]
            comment = item.value[1]
            command = item.value[2]
            if self.show_indexes:
                self.mainlist.InsertStringItem(index, str(index+1))
                self.mainlist.SetStringItem(index, 1, alias)
                next_item = 2
            else:
                self.mainlist.InsertStringItem(index, alias)
                next_item = 1
            if self.show_comment:
                self.mainlist.SetStringItem(index, next_item, comment)
                next_item += 1
            if self.show_command:
                self.mainlist.SetStringItem(index, next_item, command)
            if command == "":
                item = self.mainlist.GetItem(index)
                font = item.GetFont()
                item.SetTextColour(wx.BLUE)
                item.SetFont(font)
                self.mainlist.SetItem(item)
            if index % 2:
                self.mainlist.SetItemBackgroundColour(index, "#FFFFFF")
            else:
                self.mainlist.SetItemBackgroundColour(index, "#E0E0E0")
        self.Resize_mainlist_Columns()

    def Resize_mainlist_Columns( self ):
        size_w = self.GetSize()[0]

        if self.show_indexes:
            self.mainlist.SetColumnWidth(0, wx.LIST_AUTOSIZE)
            size_n = self.mainlist.GetColumnWidth(0)
            first_item = 1
        else:
            size_n = 0
            first_item = 0

        if not self.show_comment and not self.show_command:
            self.mainlist.SetColumnWidth(first_item, size_w-size_n)
        
        elif self.show_comment and self.show_command:
            size_a = size_w * 20 / 100
            size_b = size_w * 30 / 100
            self.mainlist.SetColumnWidth(first_item, size_a)
            self.mainlist.SetColumnWidth(first_item+1, size_b)
            self.mainlist.SetColumnWidth(first_item+2, size_w-(size_a+size_b)-size_n)

        else:
            size_a = size_w * 20 / 100
            self.mainlist.SetColumnWidth(first_item, size_a)
            self.mainlist.SetColumnWidth(first_item+1, size_w-size_a-size_n)
        
    def Add_Item_Section( self, event, item ):
        alias = item[0]
        if self.cur_tree_pos.alias_unique( alias ):
            self.cur_tree_pos.append_section( item )
            self.Populate_mainlist(frame_1.cur_tree_pos)
            self.Save_Data_To_File()
            self.Disable_LaunchAddEditDelete()
            return True
        else:
            wx.MessageBox(u'ERROR:\n\nAn item with alias/name = "{}" \nalready '
                          u'exists in this section.\n\nItem and section '
                          u'names must be unique.'.format(alias), 'Error', wx.ICON_ERROR)
            return False

    def Edit_Item_Section( self, event, item, index ):
        alias = item[0]
        if self.cur_tree_pos.alias_unique( alias, exclude=index ):
            self.cur_tree_pos.SetChildData( index, item )
            self.Populate_mainlist(frame_1.cur_tree_pos)
            self.Save_Data_To_File()
            self.Disable_LaunchAddEditDelete()
            return True
        else:
            wx.MessageBox(u'ERROR:\n\nAn item with alias/name = "{}" \nalready '
                          u'exists in this section.\n\nItem and section '
                          u'names must be unique.'.format(alias), 'Error', wx.ICON_ERROR)
            return False
   
    def OnSize(self, event):
        self.Resize_mainlist_Columns()
        event.Skip()

    def OnSelect_File_Exit(self, event): # wxGlade: MainFrame.<event_handler>
        self.Destroy()

    def OnSelect_Help_About(self, event): # wxGlade: MainFrame.<event_handler>

        description = ( u"""wxMyLauncher program keeps a list of commands to launch, """
        u"""allowing to create sections to keep them orderder.\n\nIt was originally created """
        u"""as a gnome-terminal + openssh launcher to lots of remote machines, and was """
        u"""converted to wxpython+wxglade as an example to learn wxglade+wxpython.\n""" )

        licence = ( u"""wxMyLauncher is free software; you can redistribute it and/or modify it \n"""
                    u"""under the terms of the GNU General Public License as published by the \n"""
                    u"""Free Software Foundation; either version 2 of the License, or (at your \n"""
                    u"""option) any later version.\n\nwxMyLauncher is distributed in the hope that \n"""
                    u"""it will be useful, but WITHOUT ANY WARRANTY; without even the implied \n"""
                    u"""warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\n\n"""
                    u"""See the GNU General Public License for more details. You should have \n"""
                    u"""received a copy of the GNU General Public License along with wxMyLauncher; \n"""
                    u"""if not, write to the Free Software Foundation, Inc., 59 Temple Place, \n"""
                    u"""Suite 330, Boston, MA  02111-1307  USA""" )

        info = wx.AboutDialogInfo()

        abouticon = ""
        for size in ( "48x48", "32x32", "24x24" ):
            for icon in ( "redo.png", "edit-redo.png", "document-revert.png", "forward.png" ):
               dest = os.path.join("/usr/share/icons/gnome/32x32/actions", icon )
               if os.path.exists(dest):
                  abouticon = dest
                  break

        if abouticon:
            info.SetIcon(wx.Icon( abouticon, wx.BITMAP_TYPE_PNG))
        info.SetName(u'wxMyLauncher')
        info.SetVersion('1.0')
        info.SetDescription(description)
        info.SetCopyright(u'(C) July 2011 Santiago Romero')
        info.SetWebSite(u'http://www.sromero.com')
        info.SetLicence(licence)
        info.AddDeveloper(u'Santiago Romero <sromero@sromero.org>')
        info.AddDocWriter(u'Santiago Romero <sromero@sromero.org>')
        #info.AddArtist('Santiago Romero')
        #info.AddTranslator('Santiago Romero')

        wx.AboutBox(info)

    def OnBtn_ClickAdd(self, event): # wxGlade: MainFrame.<event_handler>
        options = [u'Add new item (command)', u'Add new section']
        dlg = wx.SingleChoiceDialog(self, 'Add...', 'Add...', options, wx.CHOICEDLG_STYLE)
        if dlg.ShowModal() == wx.ID_OK:
           choose = dlg.GetStringSelection()
           dlg.Destroy()
           if choose == options[0]:
              self.Open_AddEdit_Dialog(event, "add_item", -1)
           elif choose == options[1]:
              self.Open_AddEdit_Section_Dialog(event, "add_section", -1)

    def OnBtn_ClickEdit(self, event): # wxGlade: MainFrame.<event_handler>
        indices = self.GetSelectedIndices()
        if indices:
            index = indices[0]
            item = self.mainlist_GetDataFromIndex( index )
            alias, comment, cmd = item
        if cmd:
            self.Open_AddEdit_Dialog(event, "edit_item", index)
        else:
            self.Open_AddEdit_Section_Dialog(event, "edit_section", index )

    def Open_AddEdit_Dialog(self, event, action, index=-1 ):
        dialog_addedit = AddEdit_Dialog(None, -1, "")
        if action == "add_item":
            dialog_addedit.SetTitle("Add new item")
            dialog_addedit.action = "add_item"
            dialog_addedit.index_edit = -1
        elif action == "edit_item":
            dialog_addedit.SetTitle("Edit item")
            dialog_addedit.action = "edit_item"
            dialog_addedit.index_edit = index
            item = self.mainlist_GetDataFromIndex( index )
            alias, comment, cmd = item
            dialog_addedit.AddItem_Name.SetValue(alias)
            dialog_addedit.AddItem_Comment.SetValue(comment)
            dialog_addedit.AddItem_Command.SetValue(cmd)
        dialog_addedit.ShowModal()

    def OnBtn_ClickAddSection(self, event): # wxGlade: MainFrame.<event_handler>
        self.Open_AddEdit_Section_Dialog(event, "add_section")

    def OnBtn_ClickAddItem(self, event): # wxGlade: MainFrame.<event_handler>
        self.Open_AddEdit_Dialog(event, "add_item")

    def Open_AddEdit_Section_Dialog(self, event, action, index=-1):
        dialog_addedit_section = AddEdit_Section_Dialog(None, -1, "")
        if action == "add_section":
            dialog_addedit_section.SetTitle("Add new section")
            dialog_addedit_section.action = "add_section"
            dialog_addedit_section.index_edit = -1
        elif action == "edit_section":
            dialog_addedit_section.SetTitle("Edit Section")
            dialog_addedit_section.action = "edit_section"
            dialog_addedit_section.index_edit = index
            item = self.mainlist_GetDataFromIndex( index )
            alias, comment, cmd = item
            dialog_addedit_section.AddSection_Name.SetValue(alias)
            dialog_addedit_section.AddSection_Comment.SetValue(comment)
        dialog_addedit_section.ShowModal()

    def onUnSelectItem_mainlist(self, event): # wxGlade: MainFrame.<event_handler>
        numitems = len(self.GetSelectedIndices())
        if numitems == 0:
            self.Disable_LaunchAddEditDelete()
        elif numitems == 1:
            self.Enable_LaunchAddEditDelete()

    def onSelectItem_mainlist(self, event): # wxGlade: MainFrame.<event_handler>
        num_items = len(self.GetSelectedIndices())
        selected = event.m_itemIndex
        alias, comment, command = self.mainlist_GetDataFromIndex( selected )
        if command == "" and num_items > 1:
            self.mainlist.SetItemState(selected, 0, wx.LIST_STATE_SELECTED)
        self.Enable_LaunchAddEditDelete()
        if  num_items > 1:
            self.Disable_AddEditDelete()

    def Enable_LaunchAddEditDelete(self, cmd=""):
        """Enable add/edit/launch buttons. Called when user selects items."""
        self.button_launch.Enable()
        self.button_delete.Enable()
        self.button_edit.Enable()
        self.button_moveup.Enable()
        self.button_movedown.Enable()
        self.EditItem.Enable()
        self.DeleteMenu.Enable()
        if cmd:
            self.CutMenu.Enable()
            self.CopyMenu.Enable()

    def Disable_LaunchAddEditDelete(self, cmd=""):
        """Disable add/edit/launch buttons. Called when user unselects items."""
        self.button_launch.Disable()
        self.button_delete.Disable()
        self.button_edit.Disable()
        self.button_moveup.Disable()
        self.button_movedown.Disable()
        self.EditItem.Enable(False)
        self.DeleteMenu.Enable(False)
        self.OpenItem.Enable(False)
        self.CutMenu.Enable(False)
        self.CopyMenu.Enable(False)

    def Disable_AddEditDelete(self, cmd=""):
        """Disable add/edit/launch buttons. Called when user unselects items."""
        self.button_delete.Disable()
        self.button_edit.Disable()
        self.button_moveup.Disable()
        self.button_movedown.Disable()
        self.EditItem.Enable(False)
        self.DeleteMenu.Enable(False)
        self.OpenItem.Enable(False)
        self.CutMenu.Enable(False)
        self.CopyMenu.Enable(False)

    def OnBtn_ClickOpen(self, event): # wxGlade: MainFrame.<event_handler>
        """Launch item or open section."""
        indices = self.GetSelectedIndices()
        for index in indices:
            item = self.mainlist_GetDataFromIndex( index )
            self.Execute_item( item )

    def OpenMetaItems( self, cmd ):
        """Open metaitems (!"item1", "item2"...)."""
        rows = shlex.split(cmd)
        rows = [ x.replace("\0", '') for x in rows ][1:]
        exec_list = []

        # Build commant list search all commands in the tree in the metaitem order:
        for item in rows:
            cur_size = len(exec_list)
            self.Recursive_Tree_Search( self.items_tree, item, exec_list )
            if len( exec_list ) == cur_size:
                wx.MessageBox(u'ERROR:\n\nUnknown alias/item referenced in metaitem.'
                              u'\n\nItem: "{}"\n'.format(item),
                              u'Error', wx.ICON_ERROR)

        # Now execute commands
        for command in exec_list:
            if command:
                self.Execute_item( command )

    def Recursive_Tree_Search( self, node, item, exec_list ):
        """Browse entire tree to locate items (by alias) to be executed."""

        alias, comment, command = node.value
        if command:
            if alias == item:
                exec_list.append( node.value )
        else:
            for child in node.childlist:
                self.Recursive_Tree_Search( child, item, exec_list )

    def Execute_item( self, item ):
        """Execute a single item."""
        alias, comment, cmd = item

        # Item selected:
        if cmd:
            # Special "metaitems" (start with "!"):
            if cmd.startswith('! '):
                self.OpenMetaItems( cmd )
                frame_1.Destroy()
              
            else:
                cmd = self.Replace_System_Vars( cmd )
                retcode, command2 = self.Replace_Macro_Vars( cmd )
                if retcode == -2:
                    wx.MessageBox(u'ERROR:\n\nCommand references a macro that does not exist.'
                                  u'\n\nCommand: "{}"\n'.format(cmd),
                                  u'Error', wx.ICON_ERROR)
                elif retcode == -3:
                    wx.MessageBox(u'ERROR:\n\nUnexpected macro argument in command.'
                                  u'\n\nCommand: "{}"\nUnexpected argument: "{}"'.format(cmd,command2),
                                  u'Error', wx.ICON_ERROR)
                elif retcode == -4:
                    wx.MessageBox(u'ERROR:\n\nMissing macro argument in command.'
                                  u'\n\nCommand: "{}"\nMissing argument: "{}"'.format(cmd,command2),
                                  u'Error', wx.ICON_ERROR)
                else:
                    if retcode:
                        cmd = command2[:]

                    rows = shlex.split(cmd)
                    rows = [ x.replace("\0", '') for x in rows ]
                    command = rows[0]
   
                    if not self.Check_Command_OK( command ):
                        wx.MessageBox(u'ERROR:\n\nUnable to find command in your system.'
                                      u'\n\nCommand: "{}"\n'.format(command),
                                      u'Error', wx.ICON_ERROR)
                    else:
                        try:
                            p = subprocess.Popen( cmd, shell=True, close_fds=True)
                        except:
                            wx.MessageBox(u'ERROR:\n\nCan\'t open selected command:'
                                          u'\n\nCommand: "{}"\n'.format(command),
                                          u'Error', wx.ICON_ERROR)
                        frame_1.Destroy()
            
        # Section selected:
        elif not cmd:
            index = self.Lookup_Selected_Item( frame_1.cur_tree_pos, alias, comment, cmd )
            if index != -1:
               frame_1.cur_tree_pos = frame_1.cur_tree_pos.childlist[index]
               frame_1.Populate_mainlist(frame_1.cur_tree_pos)
               if frame_1.cur_tree_pos.parent != False:
                   self.button_back.Enable()
               self.Disable_LaunchAddEditDelete()

    def Lookup_Selected_Item( self, tree, alias, comment, cmd ):
        """Search tree childs for index of the object with a given alias/comment/cmd."""
        search_value = ( alias, comment, cmd )
        if tree.childlist != "":
            for index, item in enumerate(tree.childlist):
                if item.value == search_value:
                    return index
        return -1

    def Check_Command_OK( self, cmd ):
        """Check if binary exists in path for execution."""
        # Check for command in absolute path
        if os.path.exists(cmd):
           return True

        # Check for PATH + relative command:
        basecmd = os.path.basename(cmd)
        path = os.environ['PATH']
        path = path.split(':')

        for directory in path:
            to_check = os.path.join( directory, basecmd )
            if os.path.exists( to_check ):
                return True
           
        return False

    def GetSelectedIndices( self, state =  wx.LIST_STATE_SELECTED):
        """Get indices list of selected items. Valid for SINGLE/MULTI select."""
        indices = []
        lastFound = -1
        while True:
            index = self.mainlist.GetNextItem( lastFound, wx.LIST_NEXT_ALL, state )
            if index == -1:
                break
            else:
                lastFound = index
                indices.append( index )
        return indices

    def GetDataFromIndex( self, index ):
        """Given an index, return 3 first fields of the item."""
        selected = self.mainlist.GetItemState(index, wx.LIST_STATE_SELECTED) & wx.LIST_STATE_SELECTED
        if selected:
           item = self.cur_tree_pos.childlist[index].GetData()
        else:
           item = []
        return item

    def OnBtn_ClickDelete(self, event): # wxGlade: MainFrame.<event_handler>
        """Delete selected item or section in the listctrl "mainlist"."""
        indices = self.GetSelectedIndices()
        if indices and len(indices) == 1 :
            index = indices[0]
            item = self.GetDataFromIndex( index )
            alias, comment, cmd = item
            # Item selected:
            if cmd:
                dlg = wx.MessageDialog(self, 
                         u'Are you sure you want to delete the following item?\n\n'
                         u'Alias: "{}"\nComment: "{}"\nCommand: "{}"\n\n'
                         u'This can\'t be undone.'.format(alias, comment, cmd) , 
                         u'Delete item', wx.YES | wx.NO | wx.ICON_WARNING )
                result = dlg.ShowModal()
                dlg.Destroy()
                if result == wx.ID_YES:
                    frame_1.cur_tree_pos.delete_item( index )
                elif result == wx.ID_NO:
                    return
            else:
                dlg = wx.MessageDialog(self, 
                         u'Are you sure you want to delete the following section?\n\n'
                         u'Alias: "{}"\nComment: "{}"\n\n'
                         u'This will delete all items inside the section and can\'t be undone.'.format(alias, comment) , 
                         u'Delete section', wx.YES | wx.NO | wx.ICON_WARNING )
                result = dlg.ShowModal()
                dlg.Destroy()
                if result == wx.ID_YES:
                    frame_1.cur_tree_pos.delete_section( index )
                elif result == wx.ID_NO:
                    return
            frame_1.Populate_mainlist(frame_1.cur_tree_pos)
            frame_1.Save_Data_To_File()

    def OnBtn_ClickMoveUp(self, event): # wxGlade: MainFrame.<event_handler>
        """Move item up in the mainlist."""
        indices = self.GetSelectedIndices()
        if indices:
            index = indices[0]
            limit = len(frame_1.cur_tree_pos.childlist)
            moved_to = frame_1.cur_tree_pos.child_up( index, limit )
            frame_1.Populate_mainlist(frame_1.cur_tree_pos)
            frame_1.Save_Data_To_File()
            frame_1.mainlist.Select( moved_to )

    def OnBtn_ClickMoveDown(self, event): # wxGlade: MainFrame.<event_handler>
        """Move item down in the mainlist."""
        indices = self.GetSelectedIndices()
        if indices:
            index = indices[0]
            limit = len(frame_1.cur_tree_pos.childlist)
            moved_to = frame_1.cur_tree_pos.child_down( index, limit )
            frame_1.Populate_mainlist(frame_1.cur_tree_pos)
            frame_1.Save_Data_To_File()
            frame_1.mainlist.Select( moved_to )

    def OnBtn_ClickPrevious(self, event): # wxGlade: MainFrame.<event_handler>
        """Return to previous section."""
        # If we are on root node, we can't go up
        if frame_1.cur_tree_pos.parent != False:
            frame_1.cur_tree_pos = frame_1.cur_tree_pos.parent
            if frame_1.cur_tree_pos.parent == False:
                self.button_back.Disable()
            else:
                self.button_back.Enable()
            frame_1.Populate_mainlist(frame_1.cur_tree_pos)

    def OnSelect_File_ExportAlias(self, event): # wxGlade: MainFrame.<event_handler>
        wildcard = "Text files (*.txt)|*.txt|All files (*.*)|*.*"
        dlg = wx.FileDialog( self, message="Save file as ...",  defaultFile="aliases.txt",
                             wildcard=wildcard, style=wx.SAVE|wx.OVERWRITE_PROMPT )
        dlg.SetFilterIndex(0)
        if dlg.ShowModal() == wx.ID_OK:
            destpath = dlg.GetPath()
            dlg.Destroy()
            try:
                fp = open(destpath, "w")
            except:
                wx.MessageBox(u'ERROR:\n\nCan\'t open selected file for '
                              u'writing:\n\nFilename: "{}"\n'.format(destpath),
                              u'Error', wx.ICON_ERROR)
                return
            self.items_tree.export_tree_as_aliases( fp=fp )
            fp.close()
        else:
            dlg.Destroy()

    def OnBtn_ClickCut(self, event): # wxGlade: MainFrame.<event_handler>
        """Cut object to clipboard."""
        indices = self.GetSelectedIndices()
        if indices and len(indices) == 1:
            index = indices[0]
            item = self.GetDataFromIndex( index )
            self.clipboard_alias = item[0]
            self.clipboard_comment = item[1]
            self.clipboard_command = item[2]
            if self.clipboard_command:
                frame_1.cur_tree_pos.delete_item( index )
            #else:
            #    frame_1.cur_tree_pos.delete_section( index )
                frame_1.Populate_mainlist(frame_1.cur_tree_pos)
                frame_1.Save_Data_To_File()
                self.PasteMenu.Enable()
                self.popup_paste.Enable()

    def OnBtn_ClickCopy(self, event): # wxGlade: MainFrame.<event_handler>        
        """Copy object to clipboard."""
        indices = self.GetSelectedIndices()
        if indices and len(indices) == 1:
            index = indices[0]
            item = self.GetDataFromIndex( index )
            # if the selected item is a command:
            if item[2]:
                self.clipboard_alias = item[0]
                self.clipboard_comment = item[1]
                self.clipboard_command = item[2]
            # if the selected item is a section:
            else:
                pass
            self.PasteMenu.Enable()
            self.popup_paste.Enable()

    def OnBtn_ClickPaste(self, event): # wxGlade: MainFrame.<event_handler>
        """Paste object from clipboard."""
        item = ( self.clipboard_alias, self.clipboard_comment, self.clipboard_command )
        if self.clipboard_command:
            for suffix in [ "", " (2)", " (3)", " (4)", " (5)", " (6)"," (7)", " (8)", " (9)" ]:
                name = "{}{}".format(self.clipboard_alias, suffix)
                if self.cur_tree_pos.alias_unique( name ):
                    break
            self.Add_Item_Section( False, (name, self.clipboard_comment, self.clipboard_command) )
        else:
            pass

    def OnBtn_ToggleShowIndexes(self, event): # wxGlade: MainFrame.<event_handler>
        """Toggle "Show Indexes" menu option."""
        self.show_indexes = self.ShowIndexes.IsChecked()
        self.Set_CheckMenues()
        self.Populate_mainlist(frame_1.cur_tree_pos)
        self.Save_Data_To_File()

    def OnBtn_ToggleShowComments(self, event): # wxGlade: MainFrame.<event_handler>
        """Toggle "Show Comments" menu option."""
        self.show_comment = self.ShowComments.IsChecked()
        self.Set_CheckMenues()
        self.Populate_mainlist(frame_1.cur_tree_pos)
        self.Save_Data_To_File()

    def OnBtn_ToggleShowCommands(self, event): # wxGlade: MainFrame.<event_handler>
        """Toggle "Show Commands" menu option."""
        self.show_command = self.ShowCommands.IsChecked()
        self.Set_CheckMenues()
        self.Populate_mainlist(frame_1.cur_tree_pos)
        self.Save_Data_To_File()

    def OnBtn_ToggleCenterItems(self, event): # wxGlade: MainFrame.<event_handler>
        """Toggle "Center Items" menu option."""
        self.center_items = self.CenterItems.IsChecked()
        self.Set_CheckMenues()
        self.Populate_mainlist(frame_1.cur_tree_pos)
        self.Save_Data_To_File()

    def OnBtn_ClickManageTemplates(self, event): # wxGlade: MainFrame.<event_handler>
        """User selected option "Manage templates"."""
        dialog_templates = Templates_Dialog(None, -1, "")
        dialog_templates.ShowModal()

    def OnBtn_ClickManageMacros(self, event): # wxGlade: MainFrame.<event_handler>
        """User selected option "Manage macros"."""
        macro_templates = Macros_Dialog(None, -1, "")
        macro_templates.ShowModal()

    def Check_Macro_Exists( self, macro_name ):
        """Returns True if macro exists in self.macros."""
        macro_dict = dict(self.macros)
        return macro_name in macro_dict

    def Extract_Macro_Vars( self, macro_string ):
        """Extract macro vars (${VARIABLE}) from macro string."""
        possible_vars = re.findall("\$\{[A-z0-9_]+\}", macro_string)
        # Return a list(set()) to ensure non duplicated values.
        return list(set(possible_vars))

    def Replace_Macro_Vars( self, command ):
        """Replace macro variables in the "macro command"."""

        # sample command = '@macro ${VAR1}="value" ${VAR2}="value"'
        macros = self.macros

        # If it's not a macro, return command unmodifyed
        if not command.startswith("@"):
            return (-1, command)
        else:
            # Split command with shlex -> 
            # rows: ['@macro', '${VAR1}=value', '${VAR2}=value']
            rows = shlex.split(command)
            rows = [ x.replace("\0", '') for x in rows ]

            # macro = "@macro"
            macro = rows[0]
            if not self.Check_Macro_Exists( macro ):
                return (-2, macro)

            # Get macro definition for the selected macro
            macro_data = [ x for x in macros if x[0] == macro ][0]
            macro_name = macro_data[0]
            macro_command = macro_data[1]

            defined_vars = self.Extract_Macro_Vars( macro_command )

            # Macro has no arguments:
            if len(rows) == 1 and not defined_vars:
                # check if Macros must have variables:
                return True, macro_command
                
            # Macro has arguments -> replace them
            # macro_vars = [ "${VAR1}=value", "${VAR2}="value" ]
            macro_vars = rows[1:]

            # Default return value:
            result = macro_command

            # Build a dict as dict[var] = value:
            macro_vars_dict = {}
            for variable in macro_vars:
                # for each variable found, split by the first = found
                if '=' in variable:
                    rows2 = variable.split("=", 1)
                    the_var_name = rows2[0]
                    the_var_value = rows2[1]
                    macro_vars_dict[the_var_name] = the_var_value

            # Now: macro_vars_dict = { '${VAR1}': 'value', '${VAR2}': 'value' }
            for key in macro_vars_dict:
                if key in result:
                    result = result.replace( key, macro_vars_dict[key] )
                else:
                    return (-3, key)

            for expected_var in defined_vars:
                if not expected_var in macro_vars_dict:
                    return (-4, expected_var) 

            # We've replaced each VAR with VALUE, so command now is OK
            return (True, result)

    def Replace_System_Vars( self, text ):
        """Replace some special vars in text."""

        if "${_HOST}" in text:
            value = os.uname()[1]
            text = text.replace( "${_HOST}", value )

        if "${_USER}" in text:
            text = text.replace( "${_USER}", os.environ['LOGNAME'] )

        if "${_DATE}" in text:
            now = datetime.datetime.now()
            text = text.replace( "${_DATE}", now.strftime("%d-%m-%Y") )

        if "${_TIME}" in text:
            now = datetime.datetime.now()
            text = text.replace( "${_TIME}", now.strftime("%H:%M:%S") )

        if "${_CDATE}" in text:
            now = datetime.datetime.now()
            text = text.replace( "${_CDATE}", now.strftime("%Y%m%d") )

        if "${_CTIME}" in text:
            now = datetime.datetime.now()
            text = text.replace( "${_CTIME}", now.strftime("%H%M%S") )

        return text

    def OnBtn_BasicHelp(self, event): # wxGlade: MainFrame.<event_handler>
        """Basic help."""
        
        help = u"""\nBasic help about templates, macros and metaitems:\n\n
Templates -> Predefined commands that can directly be inserted in the "Command" field.\n\n
Macros -> Macros allow user to define commands and call them by passing the required parameters.
Thanks to macros, you can change from gnome-terminal to konsole for hundreds of ssh "items"
by modifying the macro definition. Macro commands start with "@"\n
Syntax: @macroname ${PARAM1}="value1" ${PARAM2}="value2" ${EMPTYPARAM}=""\n\n
MetaItems -> MetaItems reference other items (or metaitems) by their aliases. Metaitems commands start with "! ".\n
Syntax: ! "item1" "item2" "item3"\n
"""
        wx.MessageBox( help, u'Basic Help')

# end of class MainFrame


#----------------------------------------------------------------------------
if __name__ == "__main__":

    wxmylauncher = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MainFrame(None, -1, "")

    # Open custom config file if requested in command line
    if len(sys.argv) > 1:
       frame_1.Set_Config_File(sys.argv[1])

    wxmylauncher.SetTopWindow(frame_1)
    frame_1.Show()

    # Load Data from file
    frame_1.Load_Data_From_File()

    wxmylauncher.MainLoop()


